// ------------------------------------------------------
// Shared memory functions
// ------------------------------------------------------


#include <windows.h>
#include <stdio.h>

HANDLE hFile;  
LPINT hView, aux;     

//--------------------------------------------------------
//
//
//
//--------------------------------------------------------
void CreateSharedMemoryArea()
{

	hFile = CreateFileMapping(INVALID_HANDLE_VALUE, 
		NULL,
		PAGE_READWRITE, 
		0, 
		1024 * 4, 
		"ALongFileName");
	if (hFile == NULL)
	{
		 printf("Unable to create a file.");
		 exit(1);
	}

	hView = (LPINT) MapViewOfFile(hFile, 
		FILE_MAP_ALL_ACCESS,  
		0,
		0,
		0);
	if (hView == NULL)
	{
		 printf("Unable to create a VIEW.");
		 exit(1);
	}

	aux = hView;

}    
//--------------------------------------------------------
//
//
//
//--------------------------------------------------------
void OpenSharedMemory()
{
   hFile = OpenFileMapping(FILE_MAP_ALL_ACCESS, 
		FALSE,
		"ALongFileName");            
	if (hFile == NULL)
	{
		 printf("Unable to open the shared area.\n");
		 exit(1);
	}

	hView = (LPINT) MapViewOfFile(hFile, 
		FILE_MAP_ALL_ACCESS, //FILE_MAP_WRITE | FILE_MAP_READ, 
		0,
		0,
		0);
	if (hView == NULL)
	{
		 printf("Unable to create a VIEW.\n");
		 exit(1);
	}

	aux = hView;
}
//--------------------------------------------------------
//
//
//
//--------------------------------------------------------
void DestroySharedMemoryArea ()
{

	if (!UnmapViewOfFile(hView)) 
	{ 
       printf("Could not unmap view of file."); 
	} 
	
	CloseHandle(hFile); 
    
	printf("The end.\n");
}
//--------------------------------------------------------
//
//
//
//--------------------------------------------------------
void WriteOnSharedMemory(int data, int position)
{
//	printf("Writing data on the shared area...\n");
	aux[position] = data;
}

//--------------------------------------------------------
//
//
//
//--------------------------------------------------------
void ReadFromSharedMemory(int *data, int position)
{
//	printf("Reading data on the shared area...\n");
	*data = aux[position];
}


